// camera class
// -Kyoung Shin Park (2010 Spring)
//////////////////////////////////////////////////////////////////////
#ifndef __CAMERA_H__
#define __CAMERA_H__

#include "moglclass.h"

namespace moglclass 
{

enum CameraType { DRIVE, FLY };

class Camera
{
public:
	Camera(CameraType type = DRIVE);
	~Camera();

	void strafe(float units); // left/right
	void fly(float units);    // up/down
	void walk(float units);   // forward/backward
	
	void pitch(float angle); // rotate on right vector
	void yaw(float angle);   // rotate on up vector
	void roll(float angle);  // rotate on look vector

	glm::mat4 lookAt(glm::vec3& eye, glm::vec3& at, glm::vec3& up);

	void setCameraType(CameraType type_);
	void setPosition(float x, float y, float z);
	void setPosition(const glm::vec3& pos_); 
	void setAt(float x, float y, float z);
	void setAt(const glm::vec3& at_); 

	void setRight(float x=1.0, float y=0.0, float z=0.0);
	void setRight(const glm::vec3& right_);
	void setUp(float x=0.0, float y=1.0, float z=0.0);
	void setUp(const glm::vec3& up_);
	void setLook(float x=0.0, float y=0.0, float z=1.0);
	void setLook(const glm::vec3& look_);

	glm::vec3 getPosition(); 
	glm::vec3 getRight();
	glm::vec3 getUp();
	glm::vec3 getLook();

	glm::mat4 View();

private:
 	CameraType  cameraType;

	glm::vec3 pos;
	glm::vec3 right;
	glm::vec3 up;
	glm::vec3 look;
	glm::mat4 V;
};

} // namespace

#endif // __CAMERA_H__