#pragma once
//////////////////////////////////////////////////////////////////////
// car.h: interface for the Car class.
// -Kyoung Shin Park (2014 Spring)
//////////////////////////////////////////////////////////////////////
#include "moglclass.h"
#include "geometryPositionColor.h"
#include "shaders.h"
#include <glm/gtc/type_ptr.hpp>
#include <glm/gtc/matrix_transform.hpp>

namespace moglclass
{

class SimpleCar2
{
public:
	SimpleCar2();
	~SimpleCar2() { std::cout << "~SimpleCar2" << std::endl; };
	void init();
    void draw(Program* p, glm::mat4& projection, glm::mat4& view, glm::mat4& model);
	bool update(float dt);
	void activate() { active = true; }
	void deactivate() { active = false; }

protected:
	Parallelepiped body;
	Torus wheel;
	Torus light;

	bool active;
	glm::vec3 position;
	float direction; // positive/negative direction
	float angle;// wheel angle

	void updateTransform();
	glm::mat4 bodyTransform;
	glm::mat4 wheelTransform;
};

} // moglclass namespace