#pragma once
//////////////////////////////////////////////////////////////////////
// simpleSolar.h: interface for the Car class.
// -Kyoung Shin Park (2014 Spring)
//////////////////////////////////////////////////////////////////////
#include "moglclass.h"
#include "geometryPositionColor.h"
#include "shaders.h"
#include <glm/gtc/type_ptr.hpp>
#include <glm/gtc/matrix_transform.hpp>

namespace moglclass
{

class SimpleSolar
{
public:
	SimpleSolar();
	~SimpleSolar();
	void init();
    void draw(Program* p, glm::mat4& projection, glm::mat4& view, glm::mat4& model);
	bool update(float dt);

	void activate() { active = true; }
	void deactivate() { active = false; }
	bool isActive() { return active; }

protected:
	Program* p;
	Sphere * sun;
	Sphere * earth;
	Sphere * moon;
	glm::mat4 sunTransform;
	glm::mat4 earthTransform;
	glm::mat4 moonTransform;

	float sunSpin;// sun
	float earthSpin;// earth spin
	float earthOrbit;// earth orbit around the sun
	float moonSpin;// moon spin
	float moonOrbit;// moon orbit around the earth

	static const float SunRadius;
	static const float EarthRadius;
	static const float MoonRadius;
	static const float EarthDistanceFromSun;
	static const float MoonDistanceFromEarth;

	bool active;
};

} // moglclass namespace